﻿using System;
using System.Threading;
using System.Windows.Forms;

namespace Artech.MemLeakByEvents
{
    public partial class TodoListForm : Form
    {
        public static SynchronizationContext SynchronizationContext
        { get; private set; }

        public TodoListForm()
        {
            InitializeComponent();
        }

        private void TodoListForm_Load(object sender, EventArgs e)
        {
            SynchronizationContext = SynchronizationContext.Current;
            TodoListManager.Instance.TodoListChanged += new WeakEventHandler<TodoListEventArgs>(TodoListManager_TodoListChanged);
        }

        private void TodoListManager_TodoListChanged(object sender, TodoListEventArgs e)
        {
            SynchronizationContext.Post(
                state =>
                {
                    BindingSource bindingSource = new BindingSource();
                    bindingSource.DataSource = e.TodoList;
                    this.dataGridViewTodoList.DataSource = bindingSource;
                }, null);
        }
    }
}